/* Historie s oddlovacmi komenti: 09C_Loops.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 9.0: Inicializace prosted  definice pomocnch metod a promnnch
********************************************************************/
/set start Start_07.jsh
/reset
/methods
/vars
/********************************************************************


/*
** Vpis 9.1: Ukzka pouit cyklu s ukonovac podmnkou
 *            (cyklu do-while)  definice metody clockTest_do()
********************************************************************/
void clockTest_do()
{
    long start = System.currentTimeMillis();
    int  loops = 0;
    long stop;

    do{
        loops++;
        stop = System.currentTimeMillis();
    }while (start == stop);

    System.out.println("Zmna=" + (stop-start) +
                       " ms po " + loops + ". ten" );
}
{clockTest_do();clockTest_do();clockTest_do();clockTest_do();}
/********************************************************************


/*
** Vpis 9.2: Ukzka pouit cyklu s poten podmnkou
 *            (cyklu while)  definice metody clockTest_while(int)
********************************************************************/
void clockTest_while(int attempts)
{
    int attempt = 1;
    System.out.println("===== ZATEK TESTU WHILE =====");
    while (attempt <= attempts)
    {
        System.out.print(attempt + ". pokus: ");
        clockTest_do();
        attempt++;
    }
    System.out.println("===== KONEC TESTU WHILE =====");
}
clockTest_while(10);
clockTest_while(0);
/********************************************************************


/*
** Vpis 9.3: Ukzky pouit cyklu s parametrem
 *            (cyklu for)  definice metody clockTest_for(int)
********************************************************************/
void clockTest_for(int attempts)
{
    System.out.println("===== ZATEK TESTU FOR =====");
    for (int attempt = 1;   attempt <= attempts;   attempt++)
    {
        System.out.print(attempt + ". pokus: ");
        clockTest_do();
    }
    System.out.println("===== KONEC TESTU FOR =====");
}
{clockTest_for(0); clockTest_for(2);}
/********************************************************************


/*
** Vpis 9.4: Definice metody variantArguments(int...) demonstrujc
 *            zpracovn promnnho potu argument
 *            a klov vlastnosti cyklu for
********************************************************************/
void variantArguments(int... numbers)
{
    int last = numbers.length - 1;
    String reverse = "Obrcen: [";
    print("Souet sel ");
    int sum = 0;
    for (int i=0, j=last;   j >= 0;   sum+=numbers[i], i++, j--)
    {
        print(numbers[i]);
        print((i != last)  ?  " + "  :  " = ");
        reverse += numbers[j]  +  ((j == 0)  ?  ""    :  ", " );
    }
    println(sum);
    println(reverse + ']');
}
variantArguments();
variantArguments(1, 2, 3, 4, 5);
/********************************************************************


/*
** Vpis 9.5: Ukzka pouit dvojtekovho cyklu for
********************************************************************/
void sumArguments(int... numbers)
{
    int sum = 0;
    print("Souet sel ");
    for (int number : numbers)
    {
        sum += number;
        print(number + " + ");
    }
    println("0 = " + sum);
}
sumArguments(1, 2, 3, 4, 5);
sumArguments();
/********************************************************************


/*
** Vpis 9.6: Zanoovn cykl, srovnn klasickho
 *            a dvojtekovho cyklu for
********************************************************************/
int maxInTable0(int[][] table)  //Pracuje s dvourozmrnm polem
{
    int max = Integer.MIN_VALUE;
    for (int row=0;   row < table.length;   row++) {
        for (int col=0;   col < table[row].length;   col++) {
            if (table[row][col] > max) {
                max = table[row][col];
            }
        }
    }
    return max;
}
int maxInTable1(int[][] table)  //Pracuje s polem pol
{
    int max = Integer.MIN_VALUE;
    for (int r=0;   r < table.length;   r++) {
        int[] row = table[r];
        for (int col=0;   col < row.length;   col++) {
            if (row[col] > max) {
                max = row[col];
            }
        }
    }
    return max;
}
int maxInTable2(int[][] table)  //Vyuv cyklus typu foreach
{
    int max = Integer.MIN_VALUE;
    for (int[] row : table) {
        for (int i : row) {
            if (i > max) {
                max = i;
            }
        }
    }
    return max;
}
{int[][] table = {{1, 3, 5, 7, 9}, {2, 4, 6, 8}, {0}};
println("Indexov     - max=" + maxInTable0(table));
println("dkov      - max=" + maxInTable1(table));
println("Dvojtekov  - max=" + maxInTable2(table));}
/********************************************************************


/*
** Vpis 9.7: Ukzka pouit cyklu for s przdnm tlem
********************************************************************/
int sumOfArguments(int... numbers)
{
    int sum = 0;
    for (int i=numbers.length-1;   i >= 0;   sum+=numbers[i--]);
    return sum;
}
{println("Bez parametr: suma=" + sumOfArguments());
 println("1 + 2 + 3 + 4 + 5 = " + sumOfArguments(1, 2, 3, 4, 5));}
int firstGreater(int level, int... numbers)
{
    int i=0, result;
    while((result = numbers[i++]) <= level);
    return result;
}
firstGreater(5, 1, 3, 5, 7, 9);
/********************************************************************


/*
** Vpis 9.8: Definice metody endlessLoop() s nekonenm cyklem
********************************************************************/
void endlessLoop()
{
    System.out.println("===== ZATEK NEKONENHO TESTU =====");
    for(;;)
    {
        clockTest_do();
    }
//  System.out.println("===== KONEC NEKONENHO TESTU =====");
}
/********************************************************************


/*
** Vpis 9.9: Definice metody clockTest_break(int) demonstrujc
 *            pouit cyklu s podmnkou uprosted
********************************************************************/
void clockTest_break(int duration)
{
    System.out.println("===== ZATEK TESTU =====");

    long start = System.currentTimeMillis();
    long last  = start;

    for(;;)
    {
        long now;
        int  questions = 0;
        do{
            questions++;
            now = System.currentTimeMillis();
        }while (now == last);
        int time = (int)(now - start);

        if(time >= duration) { //Podmnka testujc setrvn v cyklu
            break;                   //Pkaz k ukonen cyklu
        }
        println("as " + time + " ms, krok=" + (now-last) +
                           " ms po " + questions + ". ten" );
        last = now;
    }
    System.out.println("===== KONEC TESTU =====");
}
clockTest_break(50);
/********************************************************************


/*
** Vpis 9.10: Metoda labeledBreak() demonstrujc pouit pkazu
             break s nvtm
********************************************************************/
void labeledBreak()
{
    String as[] = {"Dobe", "Vechno patn", "Lpe"};
    for (String s : as )
    {
        println("Tlo cyklu = Start 1. blokus parametrem. " + s);
    LABEL:
        if (s != "patn") {
            println("  Start 2. bloku");
            if (s != "Nedobe") {
                println("    Start 3. bloku");
                if (s == "Vechno patn") {
                    println("      Ve je patn - konm");
                    break LABEL;
                }
                println("    Konec 3. bloku");
            }
            println("  Konec 2. bloku");
        }
        println("Konec 1. bloku, za nvtm");
    }
}
labeledBreak();
/********************************************************************


/*
** Vpis 9.11: Demonstrace funkce pkazu continue
********************************************************************/
void labeledContinue()
{
    int j = 999;
    LABEL:
    for (int i=6;   i > 0;   i--)
    {
        System.out.print("FOR: " + i);
        if (i%2 == 0) {
            System.out.println(" - je sud, beru dal");
            continue;   //Nepracuje se sudmi sly
        }
        System.out.println(" === Zpracovvm");
        j = i;
        while (--j > 0) {
            System.out.print("WHILE: " + j);
            if (j%3 == 0) { //slo dliteln temi cyklus ukon
                System.out.println(" - je dliteln temi, konm");
                continue LABEL;
            }
            System.out.println(" --- zpracovvm");
        }
        System.out.println("WHILE-cyklus probhl cel");
    }
    System.out.println("Skonil FOR-cyklus, j=" + j
                      +", pokrauje DO-cyklus");
    do {
        System.out.print("DO: " + j);
        if (j%2 != 0) {
            System.out.println(" - je lich, beru dal");
            continue;   //Nepracuje s lichmi sly
        }
        System.out.println(" -- zpracovvm");
    }while (j++ < 4);
    System.out.println("Skonil DO-cyklus");
}
/********************************************************************


/*
** Vpis 9.12: Demonstrace funkce metody labeledContinue()
********************************************************************/
labeledContinue();
/********************************************************************


/*
** Vpis 9.12: Definice metody stackOverflow(int) vedouc
 *             k peteen zsobnku
********************************************************************/
void stackOverflow(int i)
{
    System.out.println(i);
    stackOverflow(i+1);
}
//stackOverflow(1);
/********************************************************************


/*
** Vpis 9.13: Definice metody factorial(int)
********************************************************************/
long factorial(int n)
{
    return (n > 1)  ?  n * factorial(n-1)
                    :  1;
}
println("5! = " + factorial(5));
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 09H_Loops.jsh
