/* Historie s oddlovacmi komenti: 11C_ClassMembers.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 11.0: Inicializace prosted  definice pomocnch metod a promnnch
********************************************************************/
/set start Start_07.jsh
/reset
/methods
/vars
/********************************************************************


/*
** Vpis 11.1: Definice tdy Empty
********************************************************************/
class Empty {}
new Empty();
/********************************************************************


/*
** Vpis 11.2: Definice tdy Empty s explicitn definovanm konstruktorem
********************************************************************/
class Empty
{
    Empty()
    {
        println("Vytvm instanci tdy Empty: " + this);
    }
}
/2
/********************************************************************


/*
** Vpis 11.3: Pehled dosavadnch ryvk tto lekce  cel definice tdy
 *             je jeden ryvek
********************************************************************/
/list
/********************************************************************


/*
** Vpis 11.4: Definice tdy AllMembers
********************************************************************/
class AllMembers
{
//== Sekce deklarujc leny tdy = statick leny ======================

    /** Statick atribut (atribut tdy)
     *  uren k potn vytvoench instanc. */
    static int created = 0;

    /** Konstruktor objektu tdy. Nememe jej zavolat.
     *  Je zavoln v okamiku, kdy se zjist, e tdu nkdo potebuje,
     *  a mus se proto vytvoit jej objekt. */
    static {
        println("Vytvm objekt tdy AllMembers");
    }

    /** Statick metoda (metoda tdy)
     *  vypisujc poet doposud vytvoench instanc. */
    static void printCreated()
    {
        println("Doposud vytvoeno " + created + " instanc");
    }


//== Sekce deklarujc leny instanc ====================================

    /** Instann atribut pamatujc si poad vytvoen dan instance
     *  (jej rodn slo). V rmci jeho inicializace se inkrementuje
     *  statick atribut potajc vytvoen instance. */
    int ID = ++created;

    /** Konstruktor zodpovdn za inicializaci instance. */
    AllMembers()
    {
        println("Vytvm instanci s ID=" + ID);
    }

    /** Instann metoda vracejc textov podpis instance. */
    public String toString()
    {
        return "AllMembers_" + ID;
    }
}
/********************************************************************


/*
** Vpis 11.5: Vytven instanc tdy AllMembers
********************************************************************/
new AllMembers();
AllMembers[] arAM = {null, $6, new AllMembers(), new AllMembers()};
/********************************************************************


/*
** Vpis 11.6: Zasln zprv instancm tdy AllMembers
********************************************************************/
AllMembers.printCreated();
$6.toString();
_int = AllMembers.created;
_int = $6.ID;
arAM[3].toString();
/********************************************************************


/*
** Vpis 11.7: Definice tdy MC s trojic konstruktor
********************************************************************/
class MC   //Multiple constructors
{
//== Sekce deklarujc leny tdy = statick leny ======================

    /** Poet doposud vytvoench instanc. */
    static int created = 0;


//== Sekce deklarujc leny instanc ====================================

    /** Rodn slo vytvoen instance. */ int    ID;
    /** Upesujc nzev instance.     */ String name;
    /** Obalovan objekt.               */ Object wrapped;

    /** Bezparametrick konstruktor. */
    MC()
    {
        this("");
        println("   Za pouit bezparametrickho konstruktoru");
    }

    /** Konstruktor upesujc nzev instance. */
    MC(String name)
    {
        this(null, name);
        println("   Za pouit jednoparametrickho konstruktoru");
    }

    /** Konstruktor zadvajc obalovan objekt. */
    MC(Object wrapped, String name)
    {
        this.ID      = ++created;
        this.name    = name;
        this.wrapped = wrapped;
        println("Vytvm: " + this);
    }

    /** Instann metoda vracejc textov podpis instance. */
    public String toString()
    {
        return "MC(. " + ID
             + ((name == null)  ?  " bez upesujcho nzvu"
                                :  " nazvan " + name + "")
             + ((wrapped == null)  ?  " nic neobalujc"
                                   :  " obalujc " + wrapped + "")
             + ')';
    }
}
/********************************************************************


/*
** Vpis 11.8: Vytven instanc tdy MC
********************************************************************/
{
MC mc0   = new MC(),
   mc1   = new MC("Jednoparametrick"),
   mc2S  = new MC("Obalen string", "Bal string"),
   mc2O  = new MC(new Object(),     null),
   mc2MC = new MC(mc2S,             "");
}
/********************************************************************


/*
** Vpis 11.9: Autoboxing - automatick pevody hodnot primitivnch
 *             typ na instance pslunch obalovch typ a zpt
********************************************************************/
Integer tyka = 4;
int tyi = tyka;
tyka + new Double(3.14);
tyka + 3.14;
tyka + Double.valueOf(3.14);
/********************************************************************


/*
** Vpis 11.10: Pevody textovch etzc na hodnoty primitivnch typ
********************************************************************/
String number = " 12345 ";
int i = Integer.parseInt(number);
i = Integer.parseInt(number.trim());
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 11H_ClassMembers.jsh
