//Soubor: 19D_R_MDG_T.jsh
//################################## Pli luouk k pl belsk dy

/env -class-path B62_Lib_Pkg.jar
import java.util.*;
import java.util.function.*;
import java.util.regex.*;
import eu.pedu.lib20s.canvas.*;
import eu.pedu.lib20s.geom.*;
import eu.pedu.lib20s.util.*;
import eu.pedu.lib20s.dbg.IndentingReporter;


/*******************************************************************************
 *******************************************************************************
 * Metody tdy Reports slouc k demonstraci prbhu nkterch innost.
 *******************************************************************************
 ******************************************************************************/

    /***************************************************************************
     * Vype zprvu konstruktoru o typu konstruovanho objektu.
     */
    void constructorReport(Object instance, Class<?> cls)
    {
        Class<?> instanceCls = instance.getClass();
        boolean  topType     = instanceCls.equals(cls);
        String callingClass  = cls        .getSimpleName();
        String instanceClass = instanceCls.getSimpleName();
        String indent        = "                        "
                             .substring(0, callingClass.length()+2);
        System.out.println(callingClass + ": Vytvm " + instance + "\n"+
                (topType ? ""
                         : indent + "jako rodiovsk podobjekt objektu typu " +
                           instanceClass));
    }

    /***************************************************************************
     * Vytiskne argument na standardn vstup a vrt jej jako funkn hodnotu.
     */
    String intermezzo(String input)
    {
        System.out.println(input);
        return input;
    }

    /***************************************************************************
     * Vytiskne podpis argumentu na standardn vstup.
     */
    void println(Object object)
    {
        System.out.println(object);
    }

    /***************************************************************************
     * Vype podpis prvnho argumentu a zprvu zadanou v druhm.
     */
    void report(Object instance, String message)
    {
        System.out.println("\n  Instance: " + instance +
                           "\n  Zprva:   " + message);
    }

    /***************************************************************************
     * Vype nzev tdy a spust seznam metod.
     */
    <T extends Mother>
    void multireport(Class<T> cls, Runnable... methods)
    {
        System.out.println("Vpis ze tdy: " + cls.getSimpleName());
        Arrays.stream(methods).forEach(m -> m.run());
    }


/*******************************************************************************
 *******************************************************************************
* Tda matky.
 *******************************************************************************
 ******************************************************************************/

class Mother
{
    private static int created = 0;
    protected final String ID = "M"  + ++created;

    /***************************************************************************
     * Konstruktor instance matky.
     */
    public Mother()
    {
//        constructorReport(this, Mother.class);
    }

    /***************************************************************************
     * Virtuln metoda vracejc identifikan kd instance.
     */
    public String getID()
    {
        return ID;
    }

    /***************************************************************************
     * Metoda deklarovan v matce, nikde nepebit.
     */
//    @Override
    public void virtualM__()
    {
        report( this, "Verze matky  - " +
                      "M__ - Deklarovan v matce, nikde nepebit");
    }


    /***************************************************************************
     * Metoda deklarovan v matce, pebit dcerou.
     */
//    @Override
    public void virtualMD_()
    {
        report( this, "Verze matky  - " +
                      "MD_ - Deklarovan v matce, pebit dcerou");
    }


    /***************************************************************************
     * Metoda deklarovan v matce, pebit a vnukou.
     */
//    @Override
    public void virtualM_G()
    {
        report( this, "Verze matky  - " +
                      "M_G - Deklarovan v matce, pebit a vnukou");
    }


    /***************************************************************************
     * Metoda deklarovan v matce, pebit dcerou i vnukou.
     * iv verze pouit v demonstranm programu.
     */
//    @Override
    public void virtualMDG()
    {
        report( this, "Verze matky  - " +
                      "MDG - Deklarovan v matce, pebit dcerou i vnukou");
    }

    /***************************************************************************
     * Postupn zavol vechny virtuln metody sv instance.
     */
    public final void summaryMe()
    {
        System.out.println("Explicitn voln virtulnch metod tdy: " +
                            Mother.class.getSimpleName());
         this.virtualM__();      this.virtualMD_();
         this.virtualM_G();      this.virtualMDG();
    }

    /***************************************************************************
     * Vrt textov podpis instance.
     */
    @Override
    public String toString()
    {
        return "Mother_" + ID + "(Object)";
    }
}


/*******************************************************************************
 *******************************************************************************
 * Tda dcery.
 *******************************************************************************
 ******************************************************************************/

class Daughter
     extends Mother
{
    private static int created = 0;
    protected final String ID = "D"  + ++created + '-' + super.ID;

    /***************************************************************************
     * Konstruktor instance dcery.
     */
    public Daughter()
    {
//        constructorReport(this, Daughter.class);
    }


    /***************************************************************************
     * Virtuln metoda vracejc identifikan kd instance {@code this}.
     */
    @Override
    public String getID()
    {
        return ID;
    }

    /***************************************************************************
     * Metoda deklarovan v matce, pebit dcerou.
     */
    @Override
    public void virtualMD_()
    {
        report( this, "Verze dcery  - " +
                      "MD_ - Deklarovan v matce, pebit dcerou");
    }

    /***************************************************************************
     * Metoda deklarovan v matce, pebit dcerou i vnukou.
     */
    @Override
    public void virtualMDG()
    {
        report( this, "Verze dcery  - " +
                      "MDG - Deklarovan v matce, pebit dcerou i vnukou");
    }


    /***************************************************************************
     * Metoda deklarovan v dcei, nikde nepebit.
     */
//    @Override
    public void virtual_D_()
    {
        report( this, "Verze dcery  - " +
                      "_D_ - Deklarovan v dcei, nikde nepebit");
    }

    /***************************************************************************
     * Metoda deklarovan v dcei, pebit vnukou.
     */
//    @Override
    public void virtual_DG()
    {
        report( this, "Verze dcery  - " +
                      "_DG - Deklarovan v dcei, pebit vnukou");
    }


    /***************************************************************************
     * Metoda postupn zavol vechny virtuln metody sv instance.
     */
    public final void summaryDe()
    {
        System.out.println("Explicitn voln virtulnch metod tdy: " +
                           Daughter.class.getSimpleName());
         this.virtualM__();      this.virtualMD_();
         this.virtualM_G();      this.virtualMDG();
         this.virtual_D_();      this.virtual_DG ();
    }

    /***************************************************************************
     * Vrt textov podpis instance.
     */
    @Override
    public String toString()
    {
        return "Daughter_" + ID + "(" + super.toString() + ")";
    }
}


/*******************************************************************************
 *******************************************************************************
 * Tda vnuky.
 *******************************************************************************
 ******************************************************************************/

class Granddaughter
     extends Daughter
{
    private static int created = 0;
    protected final String ID = "G"  + ++created + '-' + super.ID;

    /***************************************************************************
     * Konstruktor instance vnuky.
     */
    public Granddaughter()
    {
//        constructorReport(this, Granddaughter.class);
    }

    /***************************************************************************
     * Virtuln metoda vracejc identifikan kd instance {@code this}.
     */
    @Override
    public String getID()
    {
        return ID;
    }

    /***************************************************************************
     * Metoda deklarovan v matce, pebit a vnukou.
     */
    @Override
    public void virtualM_G()
    {
        report( this, "Verze vnuky  - " +
                      "M_G - Deklarovan v matce, pebit a vnukou");
    }

    /***************************************************************************
     * Metoda deklarovan v matce, pebit dcerou i vnukou.
     */
    @Override
    public void virtualMDG()
    {
        report( this, "Verze vnuky  - " +
                      "MDG - Deklarovan v matce, pebit dcerou i vnukou");
    }

    /***************************************************************************
     * Metoda deklarovan v dcei, pebit vnukou.
     */
    @Override
    public void virtual_DG()
    {
        report( this, "Verze vnuky  - " +
                      "_DG - Deklarovan v dcei, pebit vnukou");
    }

    /***************************************************************************
     * Metoda deklarovan ve vnuce, nikde nepebit.
     */
//    @Override
    public void virtual__G()
    {
        report( this, "Verze vnuky  - " +
                      "__G - Deklarovan ve vnuce, nikde nepebit");
    }

    /***************************************************************************
     * Metoda postupn zavol vechny virtuln metody sv instance.
     */
    public final void summaryGe()
    {
        System.out.println("Explicitn voln virtulnch metod tdy: " +
                           Granddaughter.class.getSimpleName());
         this.virtualM__();      this.virtualMD_();
         this.virtualM_G();      this.virtualMDG();
         this.virtual_D_();      this.virtual_DG ();
         this.virtual__G();
    }

    /***************************************************************************
     * Vrt textov podpis instance, tj. jej etzcovou reprezentaci.
     */
    @Override
    public String toString()
    {
        return "Granddaughter_" + ID + "(" + super.toString() + ")";
    }
}


/*******************************************************************************
 *******************************************************************************
 * testovac / demonstran tda.
 *******************************************************************************
 ******************************************************************************/

class TestVirtual
{
    private static IndentingReporter IR;

    /***************************************************************************
     * Report objekt vydvajcch se za matku.
     */
    private static void motherReport(String subject, Mother mother)
    {
        IR.reportStart(subject + " vydvajc se za matku");
        mother.summaryMe();
        IR.reportEnd();
    }


    /***************************************************************************
     * Report objekt vydvajcch se za dceru.
     */
    private static void daughterReport(String subject, Daughter daughter)
    {
        IR.reportStart(subject + " vydvajc se za dceru");
        daughter.summaryDe();
        IR.reportEnd();
    }


    /***************************************************************************
     * Report objekt vydvajcch se za vnuku.
     */
    private static void granddaughterReport(String subject,
                                            Granddaughter granddaughter)
    {
        IR.reportStart(subject + " vydvajc se za vnuku");
        granddaughter.summaryGe();
        IR.reportEnd();
    }


    /***************************************************************************
     * Testuje voln virtulnch metod objekt v ppravku.
     */
    public static void testReportByRole()
    {
        Mother        mother        = new Mother();
        Daughter      daughter      = new Daughter();
        Granddaughter granddaughter = new Granddaughter();

        IR.reportStart("Reporty objekt vydvajcch se za matku"); {
            motherReport("Matka",  mother);
            motherReport("Dcera",  daughter);
            motherReport("Vnuka", granddaughter);
        }IR.reportEnd();
        IR.reportStart("Reporty objekt vydvajcch se za dceru"); {
            daughterReport("Dcera",  daughter);
            daughterReport("Vnuka", granddaughter);
        }IR.reportEnd();
        IR.reportStart("Reporty objekt vydvajcch se za vnuku");{
            granddaughterReport("Vnuka", granddaughter);
        }IR.reportEnd();
    }


    /***************************************************************************
     * Testuje voln virtulnch metod objekt v ppravku.
     */
    public static void testReportByMother()
    {
        Mother        mother        = new Mother();
        Daughter      daughter      = new Daughter();
        Granddaughter granddaughter = new Granddaughter();

        IR.reportStart("Reporty instance matky"); {
            motherReport("Matka",  mother);
        }IR.reportEnd();
        IR.reportStart("Reporty instance dcery"); {
            motherReport  ("Dcera",  daughter);
            daughterReport("Dcera",  daughter);
        }IR.reportEnd();
        IR.reportStart("Reporty instance vnuky");{
            motherReport       ("Vnuka", granddaughter);
            daughterReport     ("Vnuka", granddaughter);
            granddaughterReport("Vnuka", granddaughter);
        }IR.reportEnd();
    }


    /***************************************************************************
     * Metoda spoutjc celou aplikaci.
     */
    public static void main(String[] args)
    {
        IR = IndentingReporter.getSystemReporter();
        testReportByRole();
        System.out.println("################################################");
        testReportByMother();
    }
}

void test19MDG() {
   TestVirtual.main(new String[] {});
}

/**Vpis
**************************************************************************/
//#########################################################################
//save -history 19H_R_MDG_T.jsh
