/* Historie s oddlovacmi komenti: 21C_Exceptions.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 21.1: Ukzka vyhozen vjimky v prosted JShell
********************************************************************/
throw new RuntimeException();
void throwing()
{
    throw new RuntimeException("Cvin vyhazovan vjimka");
}
throwing();
/********************************************************************


/*
** Vpis 21.2: Definice metody cleanUpFirst() oddlujc
**            vytvoen a vyhozen vjimky
********************************************************************/
void cleanUpFirst()
{
    System.err.println("Obstarvm prostedky");
    System.err.println("Zanm vykonvat poadovanou operaci");
    RuntimeException rex = new RuntimeException(
            "\nOperace zhavarovaly protoe ...");
    System.err.println("U je uklizeno, me se vyhazovat");
    throw rex;
}
cleanUpFirst();
/********************************************************************


/*
** Vpis 21.3: Metoda unreachable() demonstrujc nedosaitelnost kdu
**             za vyhozenm vjimky
********************************************************************/
void unreachable() {
    System.err.println("Ped vyhozenm vjimky");
    throw new RuntimeException("\nZa mnou u se nic neudl");
    System.err.println("Po vyhozen vjimky");
}
/********************************************************************


/*
** Vpis 21.4: Demonstrace zachycen vyhozen vjimky
********************************************************************/
void exceptionCatching(int level)
{
    System.out.println("+++++ Pchod na hladinu "  + level);
    int breaker = 1 / level;
    System.out.println("      Dlen v hladin " + level + " se povedlo");
    try {
        exceptionCatching(level - 1);
    }catch(RuntimeException rex) {
        System.out.println("xxxxx V hladin " + level + " pila " + rex);
//        rex.printStackTrace(System.out);
    }
    System.out.println("----- Konec akce v hladin " + level);
}
exceptionCatching(2);
/********************************************************************


/*
** Vpis 21.5: Demonstrace vce blok catch + bloku finally
********************************************************************/
void multiThrow(int h)
{
    if (h<0) { throw new Error("CHYBA - Podteklo to"); }
    int    h0 = 1 / h;                  //h=0 => ArithmeticException
    String h7 = (h%3 == 0) ?  null  :  "";
           h7.toString();               //h=3 => NullPointerException
    char   hM = "ABCDEF".charAt(h + 3); //h>1 => IndexOutOfBoundsException
    System.out.println("      Pro h=" + h + " metoda multiThrow prola");
}
void catchTest(int level)
{
    System.out.println("+++++ Pchod na hladinu "  + level);
    String zprva =    "      Hladina " + level + ": ";
    try {
        multiThrow(level);
        zprva += "Test v podku";
    }
    catch(ArithmeticException | NullPointerException  e)
    {
        zprva += "Nastala vjimka typu " + e;
    }
    catch(IndexOutOfBoundsException e) {
        zprva += "Index mimo meze";
    }
    catch(RuntimeException e) {
        zprva += "Nkde se stala chyba typu " + e.getClass().getSimpleName();
    }
    catch(Throwable e) {
        zprva += "Nco se stalo - " + e.getClass().getName()
               + "\n      Pina: " + e.getMessage();
        throw new RuntimeException("Utkm z hladiny " + level);
    }
    finally {
        System.out.println(zprva);
    }
    System.out.println("----- Konec akce v hladin " + level);
    catchTest(level-1);
}
/********************************************************************


/*
** Vpis 21.6: Reakce prosted JShell po zadn pkazu catchTest(4)
********************************************************************/
catchTest(4);
/********************************************************************


/*
** Vpis 21.7: Definice vjimek CheckedException a UncheckedException
********************************************************************/
public class CheckedException extends Exception
{
    public CheckedException()                            { super(); }
    public CheckedException(String msg)                  { super(msg); }
    public CheckedException(            Throwable cause) { super(cause); }
    public CheckedException(String msg, Throwable cause) { super(msg, cause); }
}
public class UncheckedException extends RuntimeException
{
    public UncheckedException()                            { super(); }
    public UncheckedException(String msg)                  { super(msg); }
    public UncheckedException(            Throwable cause) { super(cause); }
    public UncheckedException(String msg, Throwable cause) { super(msg, cause);}
}
/********************************************************************


/*
** Vpis 21.8: Metody demonstrujc prci s kontrolovanmi a
 *             nekontrolovanmi vjimkami
********************************************************************/
/* Metoda, kter me vyhodit kontrolovanou vjimku, to mus hlsit.
*/ void throwsChecked() throws CheckedException {
       throw new CheckedException("Kontrolovan vjimka");
   }
/* Vyhazovn nekontrolovan vjimky se hlsit nemus...
*/ void throwsUnchecked() {
      throw new UncheckedException("Nekontrolovan vjimka");
   }
/* ... ale me.
*/ void throwsUnchecked() throws UncheckedException {
       throw new UncheckedException("Nekontrolovan vjimka");
   }
/* Neohlen monho vyhozen kontrolovan vjimky je syntaktick chyba.
*/ void callThrowingMtd(boolean perform) {
       if (perform) { throwsChecked(); }
   }
/* Jakmile mon vyhozen deklaruji, peklada se uklidn.
*/void callThrowingMtd(boolean perform) throws CheckedException {
    if (perform) { throwsChecked(); }
    throwsUnchecked();   //Toto hlsit nemusm
}
/* Kdy vjimku zachytm a nehroz, e ji vyhodm dl, nic nehlsm.
*/ void exceptionChecked() {
       try {
          throwsChecked();
       }catch(CheckedException e) {
           System.out.println("Oetena kontrolovan vjimka: " + e);
       }
   }
/********************************************************************


/*
** Vpis 21.8x: Voln metod z pedchozho vpisu
********************************************************************/
/*{ try {
callThrowingMtd(true);
callThrowingMtd(false);
exceptionChecked();
} catch(Exception e) {} }*/
/********************************************************************


/*
** Vpis 21.9: Definice metody conversion() pevdjc kontrolovanou 
**             vjimku na nekontrolovanou
********************************************************************/
/*
public static void conversion()
{
    try {
        throwsChecked();
    }catch(CheckedException e) {
        throw new UncheckedException("Neekan vyhozen vjimka", e);
    }
}
/********************************************************************


/*
** Vpis 21.10: Definice tdy Exceptions demonstrujc vpis obsahu 
**              zsobnku vjimek znajcch svho pvodce
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c21_exceptions\Exceptions.java
*/
/********************************************************************


/*
** Vpis 21.11: Chybov hlen po sputn tdy Exceptions z vpisu 21.10
********************************************************************/
/* Sputn:
J:\62_PGM\PRJ\14-28_Projects>c:\_PGM\Java\JDK_JRE\JDK_14\bin\java --enable-preview -jar dist/14-28_Projects.jar
*/
/********************************************************************


/*
** Vpis 21.12: Definice tdy AssertDemo pro demonstraci funkce pkazu assert
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c21_exceptions\AssertDemo.java
*/
/********************************************************************


/*
** Vpis 21.13: Definice metody getCallerName(int,int) ve td CallerReporter
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\lib20s\dbg\CallerReporter.java
*/
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 21H_Exceptions.jsh
