/* Historie s oddlovacmi komenti: ABD_Swing.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis X.0: Inicializace
********************************************************************/
import java.awt.*
import java.awt.event.*;
import javax.swing.*;

int X = 0, Y = 1, BAD = Integer.MAX_VALUE;

JFrame  frame;
JTextField[] jtf = {null, null};
int [] coordinates = {0, 0};

void axisPanel(Box box, int axis)
{
    Box        panel = new Box(BoxLayout.X_AXIS);
    JTextField input = jtf[axis] = new JTextField(""+coordinates[axis]);
    panel.add(new Label("Souadnice " + (char)('X' + axis) + ": "));
    panel.add(input);
    input.addFocusListener(new FocusAdapter()
    {
        @Override public void focusLost(FocusEvent e) {
            int value;
            try {
                value = Integer.parseInt(input.getText().trim());
            } catch(NumberFormatException nfe) {
                JOptionPane.showMessageDialog(null,
                    "patn zadan slo\nZkuste je zadat znovu");
                value = BAD;
            }
            coordinates[axis] = value;
        }
    });
    box.add(panel);
}

void addButtonPanel()
{
    JPanel  panel  = new JPanel();
    frame.add(panel, BorderLayout.SOUTH);

    JButton getButton = new JButton("Nati souadnice");
    panel.add(getButton);
    getButton.addActionListener(e -> {
        Point p = frame.getLocation();
        coordinates[X] = p.x;    jtf[X].setText(""+p.x);
        coordinates[Y] = p.y;    jtf[Y].setText(""+p.y);
    });

    JButton setButton = new JButton("Nastav souadnice");
    panel.add(setButton);
    setButton.addActionListener(e -> {
        if ((coordinates[X] != BAD)  &&  (coordinates[Y] != BAD)) {
            frame.setLocation(coordinates[X], coordinates[Y]);
        }
    });
}

JFrame swingDemo()
{
    frame = new JFrame("Demo tvorby GUI");
    Box box = new Box(BoxLayout.Y_AXIS);  //Panel panel vstupnch pol
    frame.add(box);
    axisPanel(box, X);
    axisPanel(box, Y);
    addButtonPanel();
    frame.addComponentListener(new ComponentAdapter()
    {
        @Override public void componentMoved(ComponentEvent e)
        {
            Point p = frame.getLocation();
            coordinates[X] = p.x;       jtf[X].setText(""+p.x);
            coordinates[Y] = p.y;       jtf[Y].setText(""+p.y);
        }
    });
    frame.pack();
    frame.setAlwaysOnTop(true);
    frame.setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
    frame.setVisible(true);
    return frame;
}

System.out.println("""
    ******************************************************************
    Program vytvejc okno je pipraven. Spustte jej nap. pkazem

    var win = swingDemo();

    Budete-li jej chtt ukonit bez pokusu o zaven aplikace, zadejte

    win.dispose();
    """);
/*******************************************************************/
