//Soubor: Start_06.jsh
//################################## Pli luouk k pl belsk dy

import java.util.*;
import java.util.regex.*;


/**************************************************************************
 * Klon metody ze standardn knihovny.
 *
 * @param obj Objekt, jeho textov podoba se m vytisknout
 */
void println(Object obj)
{
    System.out.println(obj);
}


/**************************************************************************
 * Klon metody ze standardn knihovny.
 *
 * @param obj Objekt, jeho textov podoba se m vytisknout
 */
void printf(String format, Object... args)
{
    System.out.printf(format, args);
}


/**************************************************************************
 * Vlo do zadanho textu znaky podtren tak, aby jej rozdlily
 * na tveice znak, peem lev skupina nemus mt pln poet znak.
 *
 * @param text Text uren k doplnn podtrtek
 * @return Vsledn text
 */
String add_(String text)
{
    Pattern p = Pattern.compile(
         "([0-9A-Fa-f])(?=([0-9A-Fa-f]{4})+(?![0-9A-Fa-f]))");
    Matcher m = p.matcher(text);
    StringBuffer sb = new StringBuffer();
    while (m.find()) {
        m.appendReplacement(sb, "$1_");
    }
    m.appendTail(sb);
    return sb.toString();
}


/**************************************************************************
 * Dopln zadan text pedstavujc slo o vodn nuly tak,
 * aby obsahoval zadan poet znak, a upraven text pak
 * nech rozdlit znaky podtren na tveice.
 *
 * @param number    Stringov reprezentace sla
 * @param positions Poadovan poet pozic
 * @return Vsledn textov podoba sla
 */
String x2len(String number, int positions)
{

//    private static final
    String ZEROES =
        "0000000000000000000000000000000000000000000000000000000000000000";
    int ZEROES_LENGTH = ZEROES.length();

    int len = number.length();
    if (len > positions) {
        number = number.substring(len - positions);
    }
    else if (len < positions) {
        String added = ZEROES.substring(ZEROES_LENGTH - positions + len);
        number = added + number;
    }
    return add_(number);
}


/**************************************************************************
 * Pevede zadan slo do hexadecimlnho tvaru se zadanm potem cifer,
 * piem jednotliv tveice slic budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @param positions Poadovan poet zobrazovanch cifer
 * @return Poadovan hexadecimln tvar sla
 */
String x2hex(long number, int positions)
{
    String  s1 = Long.toHexString(number);
    return "0x" + x2len(s1, positions);
}


/**************************************************************************
 * Pevede zadan slo do binrnho tvaru se zadanm potem cifer,
 * piem jednotliv tveice slic budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @param positions Poadovan poet zobrazovanch cifer
 * @return Poadovan hexadecimln tvar sla
 */
String x2bin(long number, int positions)
{
    String  s1 = Long.toBinaryString(number);
    return "0b" + x2len(s1, positions);
}


/**************************************************************************
 * Pevede zadan slo do plnho binrnho tvaru s 64 slicemi,
 * piem jednotliv tveice sel budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @return Poadovan binrn tvar sla
 */
String toLongBin(long number)
{
    return x2bin(number, 64);
}


/**************************************************************************
 * Pevede zadan slo do plnho binrnho tvaru s 32 slicemi,
 * piem jednotliv tveice sel budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @return Poadovan binrn tvar sla
 */
String toIntBin(long number)
{
    return x2bin(number, 32);
}


/**************************************************************************
 * Pevede zadan slo do plnho binrnho tvaru s 16 slicemi,
 * piem jednotliv tveice sel budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @return Poadovan binrn tvar sla
 */
String toShortBin(long number)
{
    return x2bin(number, 16);
}


/**************************************************************************
 * Pevede zadan slo do plnho binrnho tvaru s 8 slicemi,
 * piem jednotliv tveice sel budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @return Poadovan binrn tvar sla
 */
String toByteBin(long number)
{
    return x2bin(number, 8);
}


/**************************************************************************
 * Pevede zadan slo do plnho hexadecimlnho tvaru s 16 slicemi,
 * piem jednotliv tveice sel budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @return Poadovan hexadecimln tvar sla
 */
String toLongHex(long number)
{
    return x2hex(number, 16);
}


/**************************************************************************
 * Pevede zadan slo do plnho hexadecimlnho tvaru s 8 slicemi,
 * piem jednotliv tveice sel budou oddleny znaky podtren.
 *
 * @param number    Pevdn slo
 * @return Poadovan hexadecimln tvar sla
 */
String toIntHex(long number)
{
    return x2hex(number, 8);
}


/**************************************************************************
 * Pevede zadan slo do plnho hexadecimlnho tvaru se 4 slicemi.
 *
 * @param number    Pevdn slo
 * @return Poadovan hexadecimln tvar sla
 */
String toShortHex(long number)
{
    return x2hex(number, 4);
}


/**************************************************************************
 * Pevede zadan slo do plnho hexadecimlnho tvaru se 2 slicemi.
 *
 * @param number    Pevdn slo
 * @return Poadovan hexadecimln tvar sla
 */
String toByteHex(long number)
{
    return x2hex(number, 2);
}

boolean _boolean;
byte _byte;
short _short;
int _int;
long _long;
float _float;
double _double;
char _char;
Object _Object;
String _String = "String";

/**Vpis
**************************************************************************/
//#########################################################################
//save -history Start_06.jsh
